<template>
  <div>
    <AppWindow
        v-bind:show="show"
        title="Edit particle"
        cancelable
        @canceled="() => this.$emit('canceled')"
        width="700"
        @submitted="saveBtnClick"
        :disabled-submit="!validForm"
    >
      <br>
      <span class="heading">Preset :</span>&nbsp;&nbsp;
      <v-btn outlined color="blue" small @click="setElectronPreset">Electron</v-btn>
      &nbsp;&nbsp;
      <v-btn outlined color="red" small @click="setNeutronPreset">Proton</v-btn>
      <v-form v-model="validForm">
        <v-row>
          <v-col>
            <v-text-field
                label="Position X"
                v-model="particle.pos.x"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Position Y"
                v-model="particle.pos.y"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col>
            <v-text-field
                label="Charge"
                v-model="particle.q"
                color="secondary"
                suffix="C"
                hint="eg: 6e-12"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Mass"
                v-model="particle.m"
                color="secondary"
                suffix="kg"
                hint="eg: 5e-9"
                :rules="[isNumber, notNul, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-checkbox
                color="secondary"
                v-model="particle.locked"
                label="Locked"
            ></v-checkbox>
          </v-col>
        </v-row>
      </v-form>

      <template v-slot:submit-text>
        Save
      </template>
    </AppWindow>
  </div>
</template>

<script>
import {AppContext} from '@Util'
import AppWindow from './../AppWindow/AppWindow'

const electronPreset = {q: '-1.602e-19', m: '9.1094e-31'}
const protonPreset = {q: '1.602e-19', m: '1.6726219e-27'}

export default {
  name: 'AddParticle',
  components: {
    AppWindow
  },
  props: {
    show: Boolean,
    particle: Object,
  },
  data: () => ({
    isNumber: val => !isNaN(Number(val)) || `${val} is not a valid number`,
    notNul: val => val !== '0' || 'Must be different from 0',
    notEmpty: val => val !== '' || `Can't be empty`,
    validForm: false,
  }),
  watch: {
    show(val) {
      Object.assign(AppContext, {mode: val ? 0 : 2})
    }
  },
  methods: {
    setElectronPreset() {
      this.particle.m = electronPreset.m
      this.particle.q = electronPreset.q
    },

    setNeutronPreset() {
      this.particle.m = protonPreset.m
      this.particle.q = protonPreset.q
    },
    saveBtnClick() {
      AppContext.currentProject.resetSim()
      this.$emit('saved')
    }
  }
}
</script>